ash: rename redir5.tests (hush has redir5.tests which is different)
[oweals/busybox.git] / scripts / trylink
1 #!/bin/sh
2
3 debug=false
4
5 # Linker flags used:
6 #
7 # Informational:
8 # --warn-common
9 # -Map $EXE.map
10 # --verbose
11 #
12 # Optimizations:
13 # --sort-common                 reduces padding
14 # --sort-section alignment      reduces padding
15 # --gc-sections                 throws out unused sections,
16 #                               does not work for shared libs
17 # -On                           Not used, maybe useful?
18 #
19 # List of files to link:
20 # $l_list                       == --start-group -llib1 -llib2 --end-group
21 # --start-group $O_FILES $A_FILES --end-group
22 #
23 # Shared library link:
24 # -shared                       self-explanatory
25 # -fPIC                         position-independent code
26 # --enable-new-dtags            ?
27 # -z,combreloc                  ?
28 # -soname="libbusybox.so.$BB_VER"
29 # --undefined=lbb_main          Seed name to start pulling from
30 #                               (otherwise we'll need --whole-archive)
31 # -static                       Not used, but may be useful! manpage:
32 #                               "... This option can be used with -shared.
33 #                               Doing so means that a shared library
34 #                               is being created but that all of the library's
35 #                               external references must be resolved by pulling
36 #                               in entries from static libraries."
37
38
39 try() {
40     printf "%s\n" "Output of:" >$EXE.out
41     printf "%s\n" "$*" >>$EXE.out
42     printf "%s\n" "==========" >>$EXE.out
43     $debug && echo "Trying: $*"
44     $@ >>$EXE.out 2>&1
45     return $?
46 }
47
48 check_cc() {
49     tempname="$(mktemp tmp.XXXXXXXXXX)"
50     echo "int main(int argc,char**argv){return argv?argc:0;}" >"$tempname".c
51     # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
52     # Was using "-xc /dev/null", but we need a valid C program.
53     # "eval" may be needed if CFLAGS can contain
54     # '... -D"BB_VER=KBUILD_STR(1.N.M)" ...'
55     # and we need shell to process quotes!
56     $CC $CFLAGS $LDFLAGS $1 "$tempname".c -o "$tempname" >/dev/null 2>&1
57     exitcode=$?
58     rm -f "$tempname" "$tempname".c "$tempname".o
59     return $exitcode
60 }
61
62 check_libc_is_glibc() {
63     tempname="$(mktemp tmp.XXXXXXXXXX)"
64     echo "\
65         #include <stdlib.h>
66         /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
67         #if defined(__GLIBC__) && !defined(__UCLIBC__)
68         syntax error here
69         #endif
70         " >"$tempname".c
71     ! $CC $CFLAGS "$tempname".c -c -o "$tempname".o >/dev/null 2>&1
72     exitcode=$?
73     rm -f "$tempname" "$tempname".c "$tempname".o
74     return $exitcode
75 }
76
77 EXE="$1"
78 CC="$2"
79 CFLAGS="$3"
80 LDFLAGS="$4"
81 O_FILES="$5"
82 A_FILES="$6"
83 LDLIBS="$7"
84
85 # The --sort-section option is not supported by older versions of ld
86 SORT_SECTION="-Wl,--sort-section,alignment"
87 if ! check_cc "-Wl,--sort-section,alignment"; then
88     echo "Your linker does not support --sort-section,alignment"
89     SORT_SECTION=""
90 fi
91
92 START_GROUP="-Wl,--start-group"
93 END_GROUP="-Wl,--end-group"
94 INFO_OPTS="-Wl,--warn-common -Wl,-Map,$EXE.map -Wl,--verbose"
95
96 # gold may not support --sort-common (yet)
97 SORT_COMMON="-Wl,--sort-common"
98 if ! check_cc "-Wl,--sort-common"; then
99     echo "Your linker does not support --sort-common"
100     SORT_COMMON=""
101 fi
102
103 # Static linking against glibc produces buggy executables
104 # (glibc does not cope well with ld --gc-sections).
105 # See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
106 # Note that glibc is unsuitable for static linking anyway.
107 # We are removing -Wl,--gc-sections from link command line.
108 GC_SECTIONS="-Wl,--gc-sections"
109 if (. ./.config && test x"$CONFIG_STATIC" = x"y") then
110     if check_libc_is_glibc; then
111         echo "Static linking against glibc, can't use --gc-sections"
112         GC_SECTIONS=""
113     fi
114 fi
115 # The --gc-sections option is not supported by older versions of ld
116 if test -n "$GC_SECTIONS"; then
117     if ! check_cc "$GC_SECTIONS"; then
118         echo "Your linker does not support $GC_SECTIONS"
119         GC_SECTIONS=""
120     fi
121 fi
122
123 # Sanitize lib list (dups, extra spaces etc)
124 LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
125
126 # First link with all libs. If it fails, bail out
127 echo "Trying libraries: $LDLIBS"
128 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
129 l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
130 test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
131 try $CC $CFLAGS $LDFLAGS \
132         -o $EXE \
133         $SORT_COMMON \
134         $SORT_SECTION \
135         $GC_SECTIONS \
136         $START_GROUP $O_FILES $A_FILES $END_GROUP \
137         $l_list \
138 || {
139     echo "Failed: $l_list"
140     cat $EXE.out
141     echo 'Note: if build needs additional libraries, put them in CONFIG_EXTRA_LDLIBS.'
142     echo 'Example: CONFIG_EXTRA_LDLIBS="pthread dl tirpc audit pam"'
143     exit 1
144 }
145
146 # Now try to remove each lib and build without it.
147 # Stop when no lib can be removed.
148 while test "$LDLIBS"; do
149     $debug && echo "Trying libraries: $LDLIBS"
150     all_needed=true
151     last_needed=false
152     for one in $LDLIBS; do
153         without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
154         # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
155         l_list=`echo " $without_one " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
156         test x"$l_list" != x"" && l_list="$START_GROUP $l_list $END_GROUP"
157         $debug && echo "Trying -l options: '$l_list'"
158         try $CC $CFLAGS $LDFLAGS \
159                 -o $EXE \
160                 $SORT_COMMON \
161                 $SORT_SECTION \
162                 $GC_SECTIONS \
163                 $START_GROUP $O_FILES $A_FILES $END_GROUP \
164                 $l_list
165         if test $? = 0; then
166             echo " Library $one is not needed, excluding it"
167             LDLIBS="$without_one"
168             all_needed=false
169             last_needed=false
170         else
171             echo " Library $one is needed, can't exclude it (yet)"
172             last_needed=true
173         fi
174     done
175     # All libs were needed, can't remove any
176     $all_needed && break
177     # Optimization: was the last tried lib needed?
178     if $last_needed; then
179         # Was it the only one lib left? Don't test again then.
180         { echo "$LDLIBS" | grep -q ' '; } || break
181     fi
182 done
183
184 # Make the binary with final, minimal list of libs
185 echo "Final link with: ${LDLIBS:-<none>}"
186 l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
187 test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
188 # --verbose gives us gobs of info to stdout (e.g. linker script used)
189 if ! test -f busybox_ldscript; then
190     try $CC $CFLAGS $LDFLAGS \
191             -o $EXE \
192             $SORT_COMMON \
193             $SORT_SECTION \
194             $GC_SECTIONS \
195             $START_GROUP $O_FILES $A_FILES $END_GROUP \
196             $l_list \
197             $INFO_OPTS \
198     || {
199         cat $EXE.out
200         exit 1
201     }
202 else
203     echo "Custom linker script 'busybox_ldscript' found, using it"
204     # Add SORT_BY_ALIGNMENT to linker script (found in $EXE.out):
205     #  .rodata         : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
206     #  *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
207     #  *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
208     # This will eliminate most of the padding (~3kb).
209     # Hmm, "ld --sort-section alignment" should do it too.
210     #
211     # There is a ld hack which is meant to decrease disk usage
212     # at the cost of more RAM usage (??!!) in standard ld script:
213     #  /* Adjust the address for the data segment.  We want to adjust up to
214     #     the same address within the page on the next page up.  */
215     #  . = ALIGN (0x1000) - ((0x1000 - .) & (0x1000 - 1)); . = DATA_SEGMENT_ALIGN (0x1000, 0x1000);
216     # Replace it with:
217     #  . = ALIGN (0x1000); . = DATA_SEGMENT_ALIGN (0x1000, 0x1000);
218     # to unconditionally align .data to the next page boundary,
219     # instead of "next page, plus current offset in this page"
220     try $CC $CFLAGS $LDFLAGS \
221             -o $EXE \
222             $SORT_COMMON \
223             $SORT_SECTION \
224             $GC_SECTIONS \
225             -Wl,-T,busybox_ldscript \
226             $START_GROUP $O_FILES $A_FILES $END_GROUP \
227             $l_list \
228             $INFO_OPTS \
229     || {
230         cat $EXE.out
231         exit 1
232     }
233 fi
234
235 . ./.config
236
237 sharedlib_dir="0_lib"
238
239 if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
240     mkdir "$sharedlib_dir" 2>/dev/null
241     test -d "$sharedlib_dir" || {
242         echo "Cannot make directory $sharedlib_dir"
243         exit 1
244     }
245     ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
246
247     EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
248     try $CC $CFLAGS $LDFLAGS \
249             -o $EXE \
250             -shared -fPIC \
251             -Wl,--enable-new-dtags \
252             -Wl,-z,combreloc \
253             -Wl,-soname="libbusybox.so.$BB_VER" \
254             -Wl,--undefined=lbb_main \
255             $SORT_COMMON \
256             $SORT_SECTION \
257             $START_GROUP $A_FILES $END_GROUP \
258             $l_list \
259             $INFO_OPTS \
260     || {
261         echo "Linking $EXE failed"
262         cat $EXE.out
263         exit 1
264     }
265     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/libbusybox.so.$BB_VER"
266     chmod a+x "$sharedlib_dir/libbusybox.so.$BB_VER"
267     echo "libbusybox: $sharedlib_dir/libbusybox.so.$BB_VER"
268 fi
269
270 if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
271     EXE="$sharedlib_dir/busybox_unstripped"
272     try $CC $CFLAGS $LDFLAGS \
273             -o $EXE \
274             $SORT_COMMON \
275             $SORT_SECTION \
276             $GC_SECTIONS \
277             $START_GROUP $O_FILES $END_GROUP \
278             -L"$sharedlib_dir" -lbusybox \
279             $l_list \
280             $INFO_OPTS \
281     || {
282         echo "Linking $EXE failed"
283         cat $EXE.out
284         exit 1
285     }
286     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/busybox"
287     echo "busybox linked against libbusybox: $sharedlib_dir/busybox"
288 fi
289
290 if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
291     echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
292     gcc -DNAME_MAIN -E -include include/autoconf.h include/applets.h \
293     | grep -v "^#" \
294     | grep -v "^ *$" \
295     > applet_lst.tmp
296     while read name main junk; do
297
298         echo "\
299 void lbb_prepare(const char *applet, char **argv);
300 int $main(int argc, char **argv);
301
302 int main(int argc, char **argv)
303 {
304         lbb_prepare(\"$name\", argv);
305         return $main(argc, argv);
306 }
307 " >"$sharedlib_dir/applet.c"
308
309         EXE="$sharedlib_dir/$name"
310         try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
311                 -o $EXE \
312                 $SORT_COMMON \
313                 $SORT_SECTION \
314                 $GC_SECTIONS \
315                 -L"$sharedlib_dir" -lbusybox \
316                 -Wl,--warn-common \
317         || {
318             echo "Linking $EXE failed"
319             cat $EXE.out
320             exit 1
321         }
322         rm -- "$sharedlib_dir/applet.c" $EXE.out
323         $STRIP -s --remove-section=.note --remove-section=.comment $EXE
324         # Let user see that we do something - list the names of created binaries:
325         echo "$EXE"
326
327     done <applet_lst.tmp
328 fi
329
330 # libbusybox.so is needed only for -lbusybox at link time,
331 # it is not needed at runtime. Deleting to reduce confusion.
332 rm "$sharedlib_dir"/libbusybox.so 2>/dev/null
333 exit 0 # or else we may confuse make